import pytest

from gso.products.product_types.router import Router
from gso.utils.shared_enums import ConnectionStrategy
from test.workflows import assert_complete, run_workflow


@pytest.mark.workflow()
def test_modify_connection_strategy(router_subscription_factory):
    subscription_id = router_subscription_factory(router_access_via_ts=True)
    subscription = Router.from_subscription(subscription_id)
    assert subscription.router.router_access_via_ts is True
    form_data = [
        {"subscription_id": subscription_id},
        {"connection_strategy": ConnectionStrategy.IN_BAND},
    ]
    result, _, _ = run_workflow("modify_connection_strategy", form_data)
    assert_complete(result)

    # Fetch the updated subscription after running the workflow
    updated_subscription = Router.from_subscription(subscription_id)
    assert updated_subscription.status == "active"
    assert updated_subscription.router.router_access_via_ts is False
